diff -urN ifmail-2.15dev5-al1.20071116/ifgate/ifunpack.c ifmail-2.15dev5-al1.20071121/ifgate/ifunpack.c
--- ifmail-2.15dev5-al1.20071116/ifgate/ifunpack.c	2005-10-23 12:13:35.000000000 +0300
+++ ifmail-2.15dev5-al1.20071121/ifgate/ifunpack.c	2007-11-21 22:23:33.000000000 +0200
@@ -57,6 +57,7 @@
 extern void funlock(int);
 extern int execute(char *,char *,char *,char *,char *,char *);
 extern char *unpacker(char *);
+int compar(const struct dirent **, const struct dirent **);
 
 void usage(void)
 {
@@ -71,7 +72,8 @@
 	int rc=0,maxrc=0;
 	int files=0,files_ok=0,packets=0,packets_ok=0;
 	DIR *dp;
-	struct dirent *de;
+	struct dirent *de, **namelist;
+	int n;
 
 #if defined(HAS_SYSLOG) && defined(MAILLOG)
         logfacility=MAILLOG;
@@ -131,22 +133,32 @@
 
 	rewinddir(dp);
 
-	while((de=readdir(dp)))
-	if ((strlen(de->d_name) == 12) &&
-	    (strncasecmp(de->d_name+8,".pkt",4) == 0))
+	n = scandir(protinbound, &namelist, 0, compar);
+	if (n == -1)
+	{
+		logerr("$Error scan directory %s" ,S(protinbound));
+		exit(1);		
+	}
+	while(n--)
 	{
-		packets++;
+		de = namelist[n];
+		if ((strlen(de->d_name) == 12) &&
+		    (strncasecmp(de->d_name+8,".pkt",4) == 0))
+		{
+			packets++;
 #if defined(HAS_STATFS) | defined(HAS_STATVFS)
-		if (checkspace(newsspool,de->d_name,TOSS_FACTOR))
+			if (checkspace(newsspool,de->d_name,TOSS_FACTOR))
 #endif
-			if ((rc=toss(de->d_name)) == 0) packets_ok++;
-			else logerr("Error tossing packet %s",de->d_name);
+				if ((rc=toss(de->d_name)) == 0) packets_ok++;
+				else logerr("Error tossing packet %s",de->d_name);
 #if defined(HAS_STATFS) | defined(HAS_STATVFS)
-		else loginf("Insufficient space to toss packet %s",de->d_name);
+			else loginf("Insufficient space to toss packet %s",de->d_name);
 #endif
-		if (rc > maxrc) maxrc=rc;
+			if (rc > maxrc) maxrc=rc;
+		}
+		free(namelist[n]);
 	}
-
+	free(namelist);
 	closedir(dp);
 
 	if (files || packets)
@@ -308,3 +320,13 @@
 	return 1;
 }
 #endif
+
+int compar(const struct dirent **first, const struct dirent **second)
+{
+	struct stat first_stat;
+	struct stat second_stat;
+
+	if ((stat((*first)->d_name, &first_stat) == -1) || stat((*second)->d_name, &second_stat) == -1)
+		return 0;
+	return (int)((double)second_stat.st_mtime-(double)first_stat.st_mtime);
+}
